function sleep(n)  -- seconds
  local t0 = time()
  while time() - t0 <= n do end
end

function skinBackdrop(frame, ...)
    frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 2})
    frame:SetBackdropColor(...)
    frame:SetBackdropBorderColor(0,0,0,1)
end

function skinButton(frame, text, customwidth)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})

	frame:SetBackdropColor(0,0,0,.5)

	frame:SetHeight(22)
	if (customwidth) then
		frame:SetWidth(customwidth)
	else 
		frame:SetWidth(string.len(text)*9.4)
	end
	frame:SetScript("OnEnter", function()
		frame:SetBackdropColor(0,0,0,.9)
	end)
	frame:SetScript("OnLeave", function()
		frame:SetBackdropColor(0,0,0,.5)
	end)
	frame.text = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	frame.text:SetText(text);
	frame.text:SetJustifyH("CENTER");
	frame.text:SetTextColor(1,1,1);
	frame.text:SetPoint("CENTER", frame, "CENTER", 0, 0)
end

function getRaidIndex(unit) 
	if (UnitInRaid(unit)) then
		return UnitInRaid(unit)
	else 
		return 1
	end
end

function getItemID(link)
	local itemString = string.match(link, "item[%-?%d:]+")
	return select(2, strsplit(":", itemString))
	--local _, itemId, enchantId, jewelId1, jewelId2, jewelId3,  jewelId4, suffixId, uniqueId, linkLevel, reforgeId = strsplit(":", itemString)
end

-- Frame recycling

local function ReleaseFrame(frame)
	if (frame ~= nil) then
		frame:UnregisterAllEvents()
		frame:SetParent(nil)
		frame:Hide()
		local children = {frame:GetChildren()}
		for i = 1, #children do
			if (table.getn{children[i]:GetChildren()} > 0) then
				local children2 = {children[i]:GetChildren()}
				for v = 1, #children2 do

					if (table.getn{children2[v]:GetChildren()} > 0) then
						local children3 = {children2[v]:GetChildren()}
						for c = 1, #children3 do
							children3[c]:SetParent(nil)
							children3[c]:Hide()
							children3[c] = nil
						end
					end
					children2[v]:SetParent(nil)
					children2[v]:Hide()
					children2[v] = nil
				end
			end
			
			children[i]:SetParent(nil)
			children[i]:Hide()
			children[i] = nil
		end
		frame = nil 
	end
	
	collectgarbage()
end

function split(str, del)
	local t = {}
	local index = 0;
	while (string.find(str, del)) do
		local s, e = string.find(str, del)
		t[index] = string.sub(str, 1, s-1)
		str = string.sub(str, s+#del)
		index = index + 1;
	end
	table.insert(t, str)
	return t;
end

function tableRemoveKey(t, key)
	local newtable = {}
	for i = 1, #t do
		if (t[i] ~= key) then
			table.insert(newtable, t[i])
		end
	end
	return newtable;
end

function tableFind(t, f)
	for _,v in pairs(t) do
		if v == f then
			return true
		end
	end
end

function destroy_frame(frame)
	ReleaseFrame(frame);
end